]> diplodocus.org Git - nmh/blobdiff - test/common.sh.in
Escape literal leading full stop in man/new.man.
[nmh] / test / common.sh.in
index b2c7a7d71b5ba548bd7bcba37364cfdd49d82337..d0c446def79dc6fc1cca7e1b304d046b4c38ac44 100644 (file)
@@ -29,28 +29,19 @@ test -z "$ICONV_ENABLED"  &&  ICONV_ENABLED="@ICONV_ENABLED@"
 test -z "$OAUTH_SUPPORT"  &&  OAUTH_SUPPORT="@OAUTH_SUPPORT@"
 test -z "$CURL_USER_AGENT"  &&  CURL_USER_AGENT="@CURL_USER_AGENT@"
 
-#### If w3m is used, HOME needs to be set, assuming default w3m config.
-#### So make sure that HOME is set to avoid run-time warning about not
-#### being able to create config directory.
-test -z "$HOME"  &&  HOME=$MH_TEST_DIR
-HOME=$MH_TEST_DIR
-export HOME
-
-#### If w3m is used, HOME needs to be set, assuming default w3m config.
-#### So make sure that HOME is set to avoid run-time warning about not
-#### being able to create config directory.
-test -z "$HOME"  &&  HOME=$MH_TEST_DIR
-HOME=$MH_TEST_DIR
+#### Make sure that HOME is set to avoid run-time warning from w3m about
+#### not being able to create config directory.
+HOME="$MH_TEST_DIR"
 export HOME
 
 unset MAILDROP MHBUILD MHCONTEXT MHMTSUSERCONF MHN MHSHOW MHSTORE
-unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER
+unset MHLDEBUG MHPDEBUG MHWDEBUG PAGER XOAUTH SMTPUTF8
 #### Set LC_ALL in individual tests as needed.  Unset these so
 #### that we don't depend on user's settings in other tests.
 unset LANG LC_ALL LC_CTYPE
 
 #### Use a test dir for tmp files when MHTMPDIR applies.
-MHTMPDIR=$MH_TEST_DIR/Mail
+MHTMPDIR="$MH_TEST_DIR"/Mail
 export MHTMPDIR
 
 #### If you're reading this .... you can set MH_TEST_NOCLEANUP to prevent
@@ -110,10 +101,15 @@ require_prog ()
 }
 
 # Skip test if none of the offered locales are supported.
+# As side effect, use the first locale that is found.  Note that
+# some platforms allow, by way of example, en_US.UTF-8 to be used
+# even though en_US.UTF8 is listed by locale -a.  But by setting
+# LC_ALL here, we don't rely on that.
 require_locale ()
 {
   for locale in "$@"; do
     if locale -a | grep -i "$locale" >/dev/null; then
+        LC_ALL="$locale"; export LC_ALL
         return
     fi
   done
@@ -276,6 +272,27 @@ run_test() {
   fi
 }
 
+#### check_exit() runs the command in $2..., capturing stdout and
+#### stderr, and then tests its exit status with the test(1) condition
+#### in $1.  If that fails, the captured stdout and stderr are
+#### displayed, and $failed incremented.
+check_exit() {
+    c="$1"; shift
+    t="$MH_TEST_DIR/.check_exit"
+    r=0
+    $NMH_TEST_PREFIX "$@" >"$t.1" 2>"$t.2" || r=$?
+    if test $r $c; then
+      rm "$t.1" "$t.2"
+    else
+      echo "$0: check_exit: $r $c failed: $*" >&2
+      echo "    stdout:" >&2
+      sed 's/^/        /' "$t.1" >&2
+      echo "    stderr:" >&2
+      sed 's/^/        /' "$t.2" >&2
+      failed=`expr ${failed:-0} + 1`
+    fi
+}
+
 #### Function invoked by trap on exit.
 cleanup() {
     #### Save exit status to use as status for this program.
@@ -285,7 +302,7 @@ cleanup() {
     #### cd to $MH_TEST_DIR before trying to remove its Mail
     #### subdirectory.  rm on Solaris won't remove it if it's in the
     #### path of the current working directory.
-    test -z "$MH_TEST_NOCLEANUP" && (cd $MH_TEST_DIR; rm -rf "$MH_TEST_DIR"/Mail)
+    test -z "$MH_TEST_NOCLEANUP" && (cd "$MH_TEST_DIR"; rm -rf "$MH_TEST_DIR"/Mail)
 
     #### Report test name if set, which indicates failure.
     #### Relies on set -e to invoke the trap which calls
@@ -308,13 +325,18 @@ cleanup() {
 
 #### Function to set the test name, and whatever the future brings.
 start_test() {
-    nmh_tests_testname="$1"
+    #### run_test disables exit on non-zero status, but does increment
+    #### failed.  Don't overwrite nmh_tests_testname if there was a
+    #### failure; remember the first test that failed.
+    [ ${failed:-0} -eq 0 ]  &&  nmh_tests_testname="$1"
 }
 
 #### Corresponding function to indicate that the test has finished.  It need
 #### not be called after each test, just the last one in a file.
 finish_test() {
-    unset nmh_tests_testname
+    #### run_test disables exit on non-zero status, but does increment
+    #### failed.  Don't unset nmh_tests_testname if there was a failure.
+    [ ${failed:-0} -eq 0 ]  &&  unset nmh_tests_testname
 }
 
 setup_test ()
@@ -389,6 +411,10 @@ EOF
   fi
 
   folder -create +inbox > /dev/null
+  #### Suppress warnings about a new version.
+  #### mhparam version includes the nmh- prefix, so be consistent with that.
+  printf 'Version: nmh-%s\n' "${MH_VERSION}" >> "${MH_TEST_DIR}"/Mail/context
+
   # create 10 basic messages
   for i in 1 2 3 4 5 6 7 8 9 10;
   do